#
# spec file for package cipe (Version 1.5.4)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  kernel-source openssl openssl-devel
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils cracklib gcc gdbm gettext kernel-source libtool openssl-devel perl rpm

Name:         cipe
License:      GPL
Group:        Productivity/Networking/Security
URL:          http://sites.inka.de/sites/bigred/devel/cipe.html
Autoreqprov:  on
%if %suse_version > 800
PreReq:       %fillup_prereq %insserv_prereq %install_info_prereq
%endif
Summary:      Encrypted IP over UDP tunneling
Version:      1.5.4
Release:      451
Source:       http://sites.inka.de/~bigred/sw/%{name}-%{version}.tar.bz2
%define TEXINFO_VERSION 1.5.1
Source1:      http://sites.inka.de/~bigred/sw/%{name}-%{TEXINFO_VERSION}.texinfo
Source10:     rc.cipe
Source11:     rc.pkcipe
Source12:     Makefile.module
Source20:     README.SuSE
Source21:     LIESMICH.SuSE
Patch:        %{name}-%{version}.diff
# removed openssl-check from configure.in when building kernel-module
Patch1:       km_cipe_config.diff
# replace obsolet get_fast_time() by gettimeofday()
Patch3:       cipe-1.5.4-do_gettimeofday.diff
Patch5:       fix_noeth0availableoops.diff
Patch6:       cipe-1.5.1.texinfo.diff
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
%define KM_DIR /usr/src/kernel-modules/%{name}-%{version}
# Init scripts are in sbin for 7.0 or older, but in etc for 7.1 or newer
%define initdir %(if [ -x /sbin/insserv ]; then echo -n etc ; else echo -n sbin ; fi)/init.d

%description
CIPE (the name is shortened from *Crypto IP Encapsulation*) is a
package for an encrypting IP tunnel device. This can be used to build
encrypting routers for VPN (Virtual Private Networks) and similar
applications.



Authors:
--------
    Olaf Titz <Olaf.Titz@inka.de>

%package -n   km_cipe
Summary:      Sources for CIPE Kernel Module
Group:        Development/Sources

%description -n km_cipe
CIPE (the name is short for *Crypto IP Encapsulation*) is a package for
an encrypting IP tunnel device. This can be used to build encrypting
routers for VPN (Virtual Private Networks) and similar applications.



Authors:
--------
    Olaf Titz <Olaf.Titz@inka.de>

%prep
%setup
cp -a ${RPM_SOURCE_DIR}/%{name}-%{TEXINFO_VERSION}.texinfo ${RPM_BUILD_DIR}/%{name}-%{version}/
cp -a ${RPM_SOURCE_DIR}/README.SuSE ${RPM_BUILD_DIR}/%{name}-%{version}
cp -a ${RPM_SOURCE_DIR}/LIESMICH.SuSE ${RPM_BUILD_DIR}/%{name}-%{version}
mv ${RPM_BUILD_DIR}/%{name}-%{version}/pkcipe/README ${RPM_BUILD_DIR}/%{name}-%{version}/README.pkcipe
%patch
%patch3
%patch5
%patch6 -p1
mv %{name}-%{TEXINFO_VERSION}.texinfo %{name}.texinfo

%build
%configure_kernel_source
autoconf -I conf
if test -f /boot/vmlinuz.version.h; then
	KERNEL_VERSION=$( grep UTS_RELEASE /boot/vmlinuz.version.h | cut -f 2 -d '"')
	cp -a /boot/vmlinuz.version.h /lib/modules/${KERNEL_VERSION}/build/include/linux/version.h
	KERNEL_INC_DIR=/lib/modules/${KERNEL_VERSION}/build/include
else
	KERNEL_VERSION=$( uname -r)
        KERNEL_INC_DIR=/usr/src/linux/include
fi
export CFLAGS="-Wall ${RPM_OPT_FLAGS}"
./configure \
	--prefix=%{_prefix} \
	--libdir=%{_prefix}/%_lib \
	--exec-prefix=%{_prefix} \
	--sysconfdir=%{_sysconfdir} \
	--infodir=%{_infodir} \
	--with-linux-include=$KERNEL_INC_DIR \
	--with-ssl-libs=/usr/%_lib
%{__make}

%install
[ "${RPM_BUILD_ROOT}" != "/" -a -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT}
%{__make} \
	BINDIR=${RPM_BUILD_ROOT}/%{_sbindir} \
	INFODIR=${RPM_BUILD_ROOT}/%{_infodir} \
	bindir=${RPM_BUILD_ROOT}/%{_bindir} \
	sbindir=${RPM_BUILD_ROOT}/%{_sbindir} \
	sysconfdir=${RPM_BUILD_ROOT}/%{_sysconfdir} \
	localstatedir=${RPM_BUILD_ROOT}/%{_localstatedir} \
	install
install -D -g root -m 744 -o root -p ${RPM_SOURCE_DIR}/rc.cipe ${RPM_BUILD_ROOT}/%{initdir}/cipe
install -D -g root -m 744 -o root -p ${RPM_SOURCE_DIR}/rc.pkcipe ${RPM_BUILD_ROOT}/%{initdir}/pkcipe
ln -sf ../../%{initdir}/cipe ${RPM_BUILD_ROOT}%{_sbindir}/rccipe
ln -sf ../../%{initdir}/pkcipe ${RPM_BUILD_ROOT}%{_sbindir}/rcpkcipe
install -D -m 700 samples/ip-up ${RPM_BUILD_ROOT}/%{_sysconfdir}/cipe/ip-up
install -m 700 samples/ip-down ${RPM_BUILD_ROOT}/%{_sysconfdir}/cipe/ip-down
install -m 600 samples/options ${RPM_BUILD_ROOT}/%{_sysconfdir}/cipe/samples.options
if ! [ -x /sbin/insserv ] ; then
	# Create symbolic run level links (7.0 or older)
	rm -f $RPM_BUILD_ROOT/%{initdir}/rc*.d/*cipe
	ln -sf ../cipe $RPM_BUILD_ROOT/%{initdir}/rc2.d/S08cipe
	ln -sf ../cipe $RPM_BUILD_ROOT/%{initdir}/rc2.d/K37cipe
	ln -sf ../cipe $RPM_BUILD_ROOT/%{initdir}/rc3.d/S08cipe
	ln -sf ../cipe $RPM_BUILD_ROOT/%{initdir}/rc3.d/K37cipe
	echo /%{initdir}/rc2.d/S08cipe > filelist
	echo /%{initdir}/rc2.d/K37cipe >> filelist
	echo /%{initdir}/rc3.d/S08cipe >> filelist
	echo /%{initdir}/rc3.d/K37cipe >> filelist
else
	rm -f filelist
	touch filelist
fi
# subpackage km_cipe to build cipcb
rm -rf ${RPM_BUILD_ROOT}%{KM_DIR}
mkdir -p ${RPM_BUILD_ROOT}%{KM_DIR}
cp -a cipe/ configure.in conf/ lib/ pkcipe/ ${RPM_BUILD_ROOT}%{KM_DIR}
cp -a ${RPM_SOURCE_DIR}/Makefile.module $RPM_BUILD_ROOT%{KM_DIR}
pushd $RPM_BUILD_ROOT%{KM_DIR}
patch < %{PATCH1}
popd
# check if subpackage km_cipe can compile and install:
cp -av ${RPM_BUILD_ROOT}%{KM_DIR} ${RPM_BUILD_ROOT}%{KM_DIR}.test
pushd ${RPM_BUILD_ROOT}%{KM_DIR}.test
%{__make} -f Makefile.module
%{__make} -f Makefile.module install INSTALL_MOD_PATH=$RPM_BUILD_ROOT
test -s ${RPM_BUILD_ROOT}/lib/modules/*/misc/cipcb.o
popd
# cleanup build root
rm -rf ${RPM_BUILD_ROOT}%{KM_DIR}.test
rm -rf ${RPM_BUILD_ROOT}/lib/modules/*/misc/cipcb.o

%clean
[ "${RPM_BUILD_ROOT}" != "/" -a -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT}

%post
%{fillup_and_insserv -s cipe START_CIPED pkcipe PKCIPE}
%install_info --info-dir=%{_infodir} %{_infodir}/cipe.info.gz

%postun
%install_info_delete --info-dir=%{_infodir} %{_infodir}/cipe.info.gz
%{insserv_cleanup}

%files -f filelist
%dir /%{_sysconfdir}/cipe
%dir /%{_sysconfdir}/cipe/pk
/%{_sysconfdir}/cipe/samples.options
%config(noreplace) /%{_sysconfdir}/cipe/ip-up
%config(noreplace) /%{_sysconfdir}/cipe/ip-down
%config /%{initdir}/cipe
%config /%{initdir}/pkcipe
%{_sbindir}/ciped-cb
%{_sbindir}/rccipe
%{_sbindir}/rcpkcipe
%{_sbindir}/pkcipe
%{_prefix}/bin/rsa-keygen
%doc %{_infodir}/cipe.info.gz
%dir %{_localstatedir}/run/cipe
%doc CHANGES COPYING README README.key-bug README.pkcipe Checksums cipe.lsm tcpdump.patch README.SuSE LIESMICH.SuSE pkcipe/PKCIPE-Protocol

%files -n km_cipe
%{KM_DIR}
%dir /usr/src/kernel-modules

%changelog -n cipe
* Mon Oct 06 2003 - lmuelle@suse.de
- remove leading spaces from interface name in the cipe init script, #31964
* Fri Sep 12 2003 - ro@suse.de
- configure kernel source if needed
* Mon Sep 08 2003 - zoz@suse.de
- rccipe: get available interfaces from /proc/net/dev instead from
  /etc/sysconfig/network/ifcfg-* (bug 23528)
* Fri Jul 25 2003 - schwab@suse.de
- Fix use of tail.
* Fri Jun 13 2003 - lmuelle@suse.de
- add /usr/src/kernel-modules to the file list of km_cipe
- use macro for make
* Tue May 27 2003 - ro@suse.de
- clean up buildroot
* Thu Apr 24 2003 - ro@suse.de
- fix install_info --delete call and move from preun to postun
* Mon Mar 03 2003 - ro@suse.de
- added info-dir entry
* Mon Feb 10 2003 - lmuelle@suse.de
- use %%install_info, #23395
* Mon Nov 18 2002 - schwab@suse.de
- Fix use of obsolete autoconf option.
* Tue Aug 20 2002 - mmj@suse.de
- Correct PreReq
* Tue Aug 13 2002 - lmuelle@suse.de
- fix bug in cipe init script, start only one ciped per peer
- improve status case of cipe init script, report each peer
- remove english text from LIESMICH.SuSE
* Mon Aug 12 2002 - lmuelle@suse.de
- update to version 1.5.4
- rewrite cipe init script, #13320, #14653, #11675
- bzip2 source
- README.SuSE, LIESMICH.SuSE rewritten with previous change, #16808
* Mon Aug 05 2002 - mmj@suse.de
- START_-variables are now non-existand, and so is /sbin/init.d
* Wed Jul 31 2002 - sf@suse.de
- make dep on x86_64 to create asm/offset.h
* Tue Jul 02 2002 - ro@suse.de
- fix ip_select_ident for 2.4.18 (only first arg apparently needed)
* Tue Jun 04 2002 - ro@suse.de
- help configure with finding ssl-libs on lib64
* Thu Apr 04 2002 - ro@suse.de
- fix quotation in configure.in '[ ]' vs '" "'
- remember build-root when doing module-test-install
* Wed Apr 03 2002 - bk@suse.de
- fix init_module() to not oops on hosts without eth0 (bug 15628)
- export CFLAGS properly(don't compile with -g but optimize)
- run test-compile-install of km_cipe
* Sat Mar 02 2002 - olh@suse.de
- add patch-01-INSTALL_MOD_PATH.diff for km_cipe package
* Thu Feb 14 2002 - lmuelle@suse.de
- Fix init script bug to be LSB conform; bug #13293
* Thu Feb 07 2002 - lmuelle@suse.de
- Fix CIPE crash if received too small packets.
* Thu Feb 07 2002 - lmuelle@suse.de
- replace get_fast_time() by do_gettimeofday() needed by 2.4.18-pre8
* Mon Jan 21 2002 - ro@suse.de
- split cipe and pkcipe init script
- removed variables START_CIPED and PKCIPE
* Tue Jan 15 2002 - egmont@suselinux.hu
- removed colon from shutdown message
* Wed Oct 10 2001 - lmuelle@suse.de
- fix Makefile.modules of km_cipe; thanks to garloff and mantel
* Mon Jun 25 2001 - ro@suse.de
- make it build with new autoconf
* Tue Jun 05 2001 - kukuk@suse.de
- run "make dep" on SPARC in kernel source tree
* Mon May 14 2001 - ro@suse.de
- removed k_deflt from neededforbuild
- removed openssl-check from configure.in when building kernel-module
* Mon May 14 2001 - lmuelle@suse.de
- update to version 1.5.2
- include pkcipe
- extend startscript
* Mon Jan 29 2001 - lmuelle@suse.de
- update to version 1.4.5
- create km_cipe subpackage to generate appropriate kernel modules
- spec and dif cleanup
- remove idea related files from source tar ball
* Thu Nov 30 2000 - ro@suse.de
- startscript stuff fixed
* Wed Nov 22 2000 - choeger@suse.de
- adopted to new init scheme
* Tue Nov 14 2000 - ro@suse.de
- fixed to compile on alpha
* Tue Nov 14 2000 - choeger@suse.de
- update to version 1.4.4
* Thu Oct 12 2000 - choeger@suse.de
- update to version 1.4.2
* Wed Mar 01 2000 - choeger@suse.de
- added infodir
* Wed Mar 01 2000 - choeger@suse.de
- added Group and Url Tag
* Thu Feb 10 2000 - ro@suse.de
- replaced kernmod by k_deflt
* Wed Oct 27 1999 - ro@suse.de
- changed neededforbuild (no more old-gcc for kernel)
* Sun Oct 17 1999 - ro@suse.de
- fixed neededforbuild
* Mon Oct 11 1999 - ro@suse.de
- fixed neededforbuild
* Mon Sep 27 1999 - uli@suse.de
- %%clean: added "--nodeps" to "rpm -e lx_suse"
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Thu Jul 29 1999 - choeger@suse.de
- new version, 1.3.0
* Wed Jun 09 1999 - choeger@suse.de
- patch for fragmentation-handling
* Fri Jun 04 1999 - ro@suse.de
- use kernel-config from kernmod-package
* Tue Mar 09 1999 - choeger@suse.de
- cipe v1.2.0 for kernel 2.2.x
* Wed Dec 09 1998 - choeger@suse.de
- made init-scripts complete
* Mon Nov 23 1998 - choeger@suse.de
- new version 1.0.1
* Mon Sep 07 1998 - choeger@suse.de
- new version 1.0.0
* Wed Jul 15 1998 - choeger@suse.de
- added a fix to Makefile to find out the right kernel version
* Tue Jun 16 1998 - bs@suse.de
- fixed neededforbuild in spec file
* Wed May 13 1998 - choeger@suse.de
- new package, v0.5.6
* Mon Mar 16 1998 - choeger@suse.de
- new package, v0.5.3
